/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_putnbr_fd.c                                     :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: erey-bet <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2022/10/05 10:22:16 by erey-bet          #+#    #+#             */
/*   Updated: 2023/03/08 21:16:33 by erey-bet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "utils.h"

static int	ft_get_size(long n)
{
	long	i;

	if (n == 0)
		return (1);
	i = 0;
	n *= (n > 0) - (n < 0);
	while (n > 0)
	{
		i++;
		n = n / 10;
	}
	return (i);
}

static int	ft_power(int nb, int power)
{
	int	i;
	int	new_nb;

	if (power < 0)
		return (0);
	i = 0;
	new_nb = 1;
	while (i < power)
	{
		i++;
		new_nb *= nb;
	}
	return (new_nb);
}

void	ft_putnbr_fd(int n, int fd)
{
	int		len;
	long	nl;

	nl = n;
	if (nl < 0)
		nl *= -1;
	len = ft_get_size(nl);
	if (n < 0)
		ft_putchar_fd('-', fd);
	while (len > 1)
	{
		--len;
		ft_putchar_fd(nl / ft_power(10, len) % 10 + 48, fd);
	}
	ft_putchar_fd(nl % 10 + 48, fd);
}
